import "reflect-metadata";
import {Container} from "inversify";
import {SignInService} from "./api/auth/SignInService";
import {SignInServiceImpl} from "./impl/auth/SignInServiceImpl";
import {Cache} from "./api/state/Cache";
import {CacheImpl} from "./impl/state/CacheImpl";
import {PersistentStore} from "./api/state/PersistentStore";
import {PersistentStoreImpl} from "./impl/state/PersistentStoreImpl";
import {APIServerImpl} from "./impl/APIServerImpl";
import {config} from "node-config-ts";
import {APIServer} from "./api/APIServer";
import {Logger} from "./api/Logger";
import {LoggerImpl} from "./impl/LoggerImpl";
import {AuthenticationRoutes} from "./impl/routes/AuthenticationRoutes";
import {Constants} from "./api/Constants";

const container = new Container();
container.bind("config").toConstantValue(config);
container.bind(Logger.name).to(LoggerImpl).inSingletonScope();
container.bind(Cache.name).to(CacheImpl).inSingletonScope();
container.bind(PersistentStore.name).to(PersistentStoreImpl).inSingletonScope();
container.bind(SignInService.name).to(SignInServiceImpl).inSingletonScope();
container.bind(APIServer.name).to(APIServerImpl).inSingletonScope();
container.bind(Constants.LOAD_EAGERLY).to(AuthenticationRoutes).inSingletonScope();
export {container};
